{% extends 'public/base.html' %}

{% block styles %}
  {{super()}}
  <link href="https://unpkg.com/@fullcalendar/core@4.4.0/main.min.css" rel="stylesheet">
  <link href="https://unpkg.com/@fullcalendar/daygrid@4.4.0/main.min.css" rel="stylesheet">
  <style>
    #calendar {
      max-width: 900px;
      margin: 40px auto;
    }
  </style>
{% endblock %}

{% block scripts %}
  <script src="https://unpkg.com/@fullcalendar/core@4.4.0/main.min.js"></script>
  <script src="https://unpkg.com/@fullcalendar/daygrid@4.4.0/main.min.js"></script>
  <script>
    function getTime(time) {
      var now = new Date(time);
      return (((now.getHours() < 10)
                  ? ("0" + now.getHours())
                  : (now.getHours())) + ':' +
              ((now.getMinutes() < 10)
                  ? ("0" + now.getMinutes())
                  : (now.getMinutes())));
    }

    function getTimeDiff(num) {
      var hours = (num / 60);
      var rhours = Math.floor(hours);
      var minutes = (hours - rhours) * 60;
      var rminutes = Math.round(minutes);
      return (((rhours < 10)
                  ? ("0" + rhours)
                  : (rhours)) + ':' +
              ((rminutes < 10)
                  ? ("0" + rminutes)
                  : (rminutes)));
    }

    function getTextContent(info){
      if (info.event.extendedProps.type == 'Live'){
        let html ="<p>"+"Position : "+info.event.title+"</p>"
          +"<p>"+"Member : "+info.event.extendedProps.controller+" - " + info.event.extendedProps.controller_name + "</p>"
          +"<p>"+"Start : "+getTime(info.event.start)+"</p>"
          +"<p>"+"End : "+getTime(info.event.end)+"</p>"
          +"<p>"+"Duration : "+getTimeDiff(info.event.extendedProps.duration_min)+"</p>";
          return html;
      }
      else {
        let html ="<p>"+"Position : "+info.event.title+"</p>"
          +"<p>"+"Member : "+info.event.extendedProps.controller+" - " + info.event.extendedProps.controller_name + "</p>"
          +"<p>"+"Start : "+getTime(info.event.start)+"</p>"
          +"<p>"+"End : "+getTime(info.event.end)+"</p>"
          +"<p>"+"Duration : "+getTimeDiff(info.event.extendedProps.duration_min)+"</p>"
          +"<p>"+"Mentor : "+info.event.extendedProps.mentor+" - " + info.event.extendedProps.mentor_name + "</p>";
          return html;
      }
    }

    document.addEventListener('DOMContentLoaded', function() {
      var calendarEl = document.getElementById('calendar');
      var data = JSON.parse('{{scheduling|tojson}}')
      var calendar = new FullCalendar.Calendar(calendarEl, {
        plugins: [ 'dayGrid' ],
        defaultView: 'dayGridMonth',
        defaultDate: new Date(),
        events: data,
        eventTimeFormat: {
          hour: '2-digit',
          minute: '2-digit',
          meridiem: false,
          hour12: false
        },
        eventRender: function (info) {
          //$(info.el).tooltip({ title: info.event.title });
          $(info.el).popover({
            title: info.event.extendedProps.type + ' Session',
            html: true,
            content: getTextContent(info),
            trigger: "hover",
            placement: "top",
          });
        },
      });

      calendar.render();
    });

  </script>
  {{super()}}
{% endblock %}

{% block page_content %}
  <div class="row" style="margin-top: 25px;">
    <div class="col-lg-2"></div>
    <div class="col-lg-10">
      <h2 class="hpage">ATC Scheduling</h2>
    </div>
    <div class="col-lg-2"></div>
  </div>
  <hr>
  <div id='calendar'></div>
{% endblock %}
